/*
 * $Id: Accel.java,v 1.2 2002/10/02 16:00:43 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.bulletmlkxml;

import org.kxml.*;
import org.kxml.parser.*;
import java.io.*;

/**
 * Accel xml data.
 *
 * @version $Revision: 1.2 $
 */
public class Accel implements IActionChoice {
  private Horizontal horizontal;
  private Vertical vertical;
  private String term;

  public Accel(ParseEvent pe, XmlParser parser) throws IOException {
    do {
      parser.skip();
      pe = parser.read();
      if ( pe.getType() == Xml.START_TAG ) {
        String name = pe.getName();
        if ( name.equals("horizontal") ) {
          horizontal = new Horizontal(pe, parser);
        } else if ( name.equals("vertical") ) {
          vertical = new Vertical(pe, parser);
        } else if ( name.equals("term") ) {
          pe = parser.read();
          term = pe.getText();
        }
      }
    } while ( pe.getType() != Xml.END_TAG || !pe.getName().equals("accel") );
  }

  public final Horizontal getHorizontal() {
    return horizontal;
  }

  public final Vertical getVertical() {
    return vertical;
  }

  public final String getTerm() {
    return term;
  }
}
