/*
 * $Id: ChangeDirection.java,v 1.2 2002/10/02 16:00:45 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.bulletmlkxml;

import org.kxml.*;
import org.kxml.parser.*;
import java.io.*;

/**
 * ChangeDirection xml data.
 *
 * @version $Revision: 1.2 $
 */
public class ChangeDirection implements IActionChoice {
  private Direction direction;
  private String term;

  public ChangeDirection(ParseEvent pe, XmlParser parser) throws IOException {
    do {
      parser.skip();
      pe = parser.read();
      if ( pe.getType() == Xml.START_TAG ) {
        String name = pe.getName();
        if ( name.equals("direction") ) {
          direction = new Direction(pe, parser);
        } else if ( name.equals("term") ) {
          pe = parser.read();
          term = pe.getText();
        }
      }
    } while ( pe.getType() != Xml.END_TAG || !pe.getName().equals("changeDirection") );
  }

  public final Direction getDirection() {
    return direction;
  }

  public final String getTerm() {
    return term;
  }
}
