/*
 * $Id: Fire.java,v 1.2 2002/10/02 16:00:45 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.bulletmlkxml;

import org.kxml.*;
import org.kxml.parser.*;
import java.io.*;

/**
 * Fire xml data.
 *
 * @version $Revision: 1.2 $
 */
public class Fire implements IActionChoice {
  private String label;
  private Direction direction;
  private Speed speed;
  private IBulletElmChoice bullet;

  public Fire(ParseEvent pe, XmlParser parser) throws IOException {
    Attribute ab = pe.getAttribute("label");
    if ( ab != null ) label = ab.getValue();
    do {
	    parser.skip();
      pe = parser.read();
      if ( pe.getType() == Xml.START_TAG ) {
        String name = pe.getName();
        if ( name.equals("direction") ) {
          direction = new Direction(pe, parser);
        } else if ( name.equals("speed") ) {
          speed = new Speed(pe, parser);
        } else if ( name.equals("bullet") ) {
          bullet = new Bullet(pe, parser);
        } else if ( name.equals("bulletRef") ) {
          bullet = new BulletRef(pe, parser);
        }
      }
    } while ( pe.getType() != Xml.END_TAG || !pe.getName().equals("fire") );
  }

  public final String getLabel() {
    return label;
  }

  public final Direction getDirection() {
    return direction;
  }

  public final Speed getSpeed() {
    return speed;
  }

  public final IBulletElmChoice getBulletElm() {
    return bullet;
  }
}
