/*
 * $Id: Screen.java,v 1.3 2002/10/03 15:56:48 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.bulletmlkxml;

import jp.gr.java_conf.abagames.noiz2.*;
import java.awt.*;
import java.awt.image.*;
//import java.util.Random;

/**
 * Draw a game screen.
 *
 * @version $Revision: 1.3 $
 */
public class Screen {
  /*private int pbuf[];
  private int bpbuf[];
  private int pbuf1[], pbuf2[];
  private int clrdBuf[];
  private int bufBldIdx[];
  private MemoryImageSource imageSource;
  private Image bufImage;*/

  public static final int WIDTH  = 240,
                          HEIGHT = 288;//320;

  //private Random rnd = new Random();

  public Screen() {
    /*pbuf1 = new int[WIDTH * HEIGHT+1];
    pbuf2 = new int[WIDTH * HEIGHT+1];
    pbuf = pbuf1; bpbuf = pbuf2;

    // Make the buffer for a blur effect.
    pbuf1[pbuf1.length-1] = pbuf2[pbuf2.length-1] = 0;
    bufBldIdx = new int[WIDTH*HEIGHT];
    for ( int i = WIDTH*HEIGHT-1 ; i>=0 ; i-- ){
      int y = i/WIDTH;
      int x = i - y*WIDTH;
      x -= WIDTH/2; y -= HEIGHT/2;
      //x += (rnd.nextInt()%3);
      //y += (rnd.nextInt()%3);
      //x += Math.sin(3.14*0.05*x)/150;
      //y += Math.sin(3.14*0.05*y)/150;
      //x += Math.sin(3.14*0.05*x)/50;
      //y += Math.sin(3.14*0.05*y)/50;
      x += WIDTH/2; y += HEIGHT/2;
      if ( x>=0 && x<WIDTH && y>=0 && y<HEIGHT ) {
        bufBldIdx[i] = x+y*WIDTH;
      } else {
        bufBldIdx[i] = pbuf1.length-1;
      }
    }

    //pbuf = new int[WIDTH * HEIGHT];

    clrdBuf = new int[WIDTH * HEIGHT];
    for ( int i=clrdBuf.length-1 ; i>=0 ; i-- ){
      clrdBuf[i] = 0xff000000;
    }*/
  }

  private Image backBuffer;
  private Graphics bbGrp;

  /**
   * Make a screen buffer(off screen image).
   */
  public void makeBuffer(Component cmp) {
    /*imageSource = new MemoryImageSource
      (WIDTH, HEIGHT, pbuf, 0, WIDTH);
    imageSource.setAnimated(true);
    bufImage = cmp.createImage(imageSource);
    grp = cmp.getGraphics();

    backBuffer = cmp.createImage(WIDTH, HEIGHT);
    bbGrp = backBuffer.getGraphics();*/

    grp = null; backBuffer = null; bbGrp = null;
    System.gc();

    grp = cmp.getGraphics();
    backBuffer = cmp.createImage(WIDTH, HEIGHT);
    bbGrp = backBuffer.getGraphics();
  }

  /*private boolean blur = false;

  public void setBlur(boolean f) {
    blur = f;
  }*/

  private Color backColor = new Color(0, 0, 0);

  /**
   * Clear the screen and make a blur effect.
   */
  public final void clear() {
    /*if ( !blur ) {
      System.arraycopy(clrdBuf, 0, pbuf, 0, clrdBuf.length);
    } else {
      System.arraycopy(pbuf, 0, bpbuf, 0, bufBldIdx.length);
      for ( int i=bufBldIdx.length-1 ; i>=0 ; i-- ){
        int px = bpbuf[bufBldIdx[i]];
        int r = (((px&0xff0000)>>8 ) * 200)&0xff0000;
        int g = (((px&0x00ff00)>>8 ) * 160)&0x00ff00;
        int b =  ((px&0x0000ff)    ) * 240 >> 8;
        pbuf[i] = 0xff000000 | r | g | b;
      }
    }*/
    bbGrp.setColor(backColor);
    bbGrp.fillRect(0, 0, WIDTH, HEIGHT);
  }

  private ColorModel colorModel = ColorModel.getRGBdefault();
  private Graphics grp;

  private AttractManager atMng;

  public void setAttractManager(AttractManager atMng) {
    this.atMng = atMng;
  }

  public final void swap() {
    /*imageSource.newPixels();
    if ( atMng != null ) {
      bbGrp.drawImage(bufImage, 0, 0, null);
      atMng.drawTitleBoard(bbGrp);
      grp.drawImage(backBuffer, 0, 0, null);
    } else {
      grp.drawImage(bufImage, 0, 0, null);
    }*/
    if ( atMng != null ) {
      atMng.drawTitleBoard(bbGrp);
    }
    grp.drawImage(backBuffer, 0, 0, null);
  }

  /*
   * Draw a line/dot.
   */

  public final void setColor(Color color) {
    bbGrp.setColor(color);
  }

  public final void drawLine(int x1, int y1, int x2, int y2) {
    bbGrp.drawLine(x1, y1, x2, y2);
  }

  public final void drawThickLine(int x1, int y1, int x2, int y2) {
    if ( Math.abs(x1-x2) > Math.abs(y2-y1) ) {
      bbGrp.drawLine(x1, y1-1, x2, y2-1);
      bbGrp.drawLine(x1, y1, x2, y2);
      bbGrp.drawLine(x1, y1+1, x2, y2+1);
    } else {
      bbGrp.drawLine(x1-1, y1, x2-1, y2);
      bbGrp.drawLine(x1, y1, x2, y2);
      bbGrp.drawLine(x1+1, y1, x2+1, y2);
    }
  }

  private int dc = 0;

  public final void drawDot(int x, int y) {
    dc++;
    if ( (dc&1) == 0 ) {
      bbGrp.drawLine(x, y, x+1, y+1);
    } else {
      bbGrp.drawLine(x+1, y, x, y+1);
    }
  }

  /*public final void drawLine(int x1, int y1, int x2, int y2, int color) {
    if ( x1 < 1 ) {
      if ( x2 < 1 ) return;
      y1 = (y1-y2)*(x2-1)/(x2-x1)+y2;
      x1 = 1;
    } else if ( x2 < 1 ) {
      y2 = (y2-y1)*(x1-1)/(x1-x2)+y1;
      x2 = 1;
    }
    if ( x1 > WIDTH-2 ) {
      if ( x2 > WIDTH-2 ) return;
      y1 = (y1-y2)*(x2-(WIDTH-2))/(x2-x1)+y2;
      x1 = WIDTH-2;
    } else if ( x2 > WIDTH-2 ) {
      y2 = (y2-y1)*(x1-(WIDTH-2))/(x1-x2)+y1;
      x2 = WIDTH-2;
    }

    if ( y1 < 1 ) {
      if ( y2 < 1 ) return;
      x1 = (x1-x2)*(y2-1)/(y2-y1)+x2;
      y1 = 1;
    } else if ( y2 < 1 ) {
      x2 = (x2-x1)*(y1-1)/(y1-y2)+x1;
      y2 = 1;
    }
    if ( y1 > HEIGHT-2 ) {
      if ( y2 > HEIGHT-2 ) return;
      x1 = (x1-x2)*(y2-(HEIGHT-2))/(y2-y1)+x2;
      y1 = HEIGHT-2;
    } else if ( y2 > HEIGHT-2 ) {
      x2 = (x2-x1)*(y1-(HEIGHT-2))/(y1-y2)+x1;
      y2 = HEIGHT-2;
    }

    int lx = Math.abs(x2 - x1);
    int ly = Math.abs(y2 - y1);

    if ( lx < ly ) {
      if ( ly == 0 ) ly++;
      int ax = ((x2 - x1)<<16) / ly;
      int ay = ((y2 - y1)>>16) | 1;
      int x  = x1<<16;
      int y  = y1;
      for ( int i=ly-1 ; i>=0 ; i--, x+=ax, y+=ay ){
        int px = x>>16;
        int p1 = y * WIDTH + px;
        pbuf[p1] = color;
      }
    } else {
      if ( lx == 0 ) lx++;
      int ay = ((y2 - y1)<<16) / lx;
      int ax = ((x2 - x1)>>16) | 1;
      int x  = x1;
      int y  = y1<<16;
      for ( int i=lx-1 ; i>0 ; i--, x+=ax, y+=ay ) {
        int py = y>>16;
        int p1 = py * WIDTH + x;
        pbuf[p1] = color;
      }
    }
  }*/

  /*public final void drawThickLine(
   int x1, int y1, int x2, int y2, int color1, int color2) {
    if ( x1 < 1 ) {
      if ( x2 < 1 ) return;
      y1 = (y1-y2)*(x2-1)/(x2-x1)+y2;
      x1 = 1;
    } else if ( x2 < 1 ) {
      y2 = (y2-y1)*(x1-1)/(x1-x2)+y1;
      x2 = 1;
    }
    if ( x1 > WIDTH-2 ) {
      if ( x2 > WIDTH-2 ) return;
      y1 = (y1-y2)*(x2-(WIDTH-2))/(x2-x1)+y2;
      x1 = WIDTH-2;
    } else if ( x2 > WIDTH-2 ) {
      y2 = (y2-y1)*(x1-(WIDTH-2))/(x1-x2)+y1;
      x2 = WIDTH-2;
    }

    if ( y1 < 1 ) {
      if ( y2 < 1 ) return;
      x1 = (x1-x2)*(y2-1)/(y2-y1)+x2;
      y1 = 1;
    } else if ( y2 < 1 ) {
      x2 = (x2-x1)*(y1-1)/(y1-y2)+x1;
      y2 = 1;
    }
    if ( y1 > HEIGHT-2 ) {
      if ( y2 > HEIGHT-2 ) return;
      x1 = (x1-x2)*(y2-(HEIGHT-2))/(y2-y1)+x2;
      y1 = HEIGHT-2;
    } else if ( y2 > HEIGHT-2 ) {
      x2 = (x2-x1)*(y1-(HEIGHT-2))/(y1-y2)+x1;
      y2 = HEIGHT-2;
    }

    int lx = Math.abs(x2 - x1);
    int ly = Math.abs(y2 - y1);

    if ( lx < ly ) {
      if ( ly == 0 ) ly++;
      int ax = ((x2 - x1)<<16) / ly;
      int ay = ((y2 - y1)>>16) | 1;
      int x  = x1<<16;
      int y  = y1;
      for ( int i=ly-1 ; i>=0 ; i--, x+=ax, y+=ay ){
        int px = (x>>16) - 1;
        int p1 = y * WIDTH + px;
        int p2 = p1 + 1;
        int p3 = p2 + 1;
        pbuf[p1] = color1;
        pbuf[p2] = color2;
        pbuf[p3] = color1;
      }
    } else {
      if ( lx == 0 ) lx++;
      int ay = ((y2 - y1)<<16) / lx;
      int ax = ((x2 - x1)>>16) | 1;
      int x  = x1;
      int y  = y1<<16;
      for ( int i=lx-1 ; i>0 ; i--, x+=ax, y+=ay ) {
        int py = (y>>16) - 1;
        int p1 = py * WIDTH + x;
        int p2 = p1 + WIDTH;
        int p3 = p2 + WIDTH;
        pbuf[p1] = color1;
        pbuf[p2] = color2;
        pbuf[p3] = color1;
      }
    }
  }*/

  /*private int dc = 0;

  public final void drawDot(int x, int y, int color) {
    if ( x < 0 || x >= WIDTH-1 || y < 0 || y >= HEIGHT-1 ) return;
    dc++;
    if ( (dc&1) == 0 ) {
      pbuf[x+y*WIDTH] = color;
      pbuf[x+1+y*WIDTH+WIDTH] = color;
    } else {
      pbuf[x+1+y*WIDTH] = color;
      pbuf[x+y*WIDTH+WIDTH] = color;
    }
  }*/

}
